Index: drivers/filesystems/btrfs/flushthread.c
===================================================================
--- drivers/filesystems/btrfs/flushthread.c	(révision 75772)
+++ drivers/filesystems/btrfs/flushthread.c	(copie de travail)
@@ -4469,18 +5202,23 @@
         }
 
         if (!keycmp(tp.item->key, searchkey)) {
-            delete_tree_item(Vcb, &tp, rollback);
+            Status = delete_tree_item(Vcb, &tp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                return Status;
+            }
         }
     }
-    
-    if (c->chunk_item->type & BLOCK_FLAG_RAID0)
-        factor = c->chunk_item->num_stripes;
-    else if (c->chunk_item->type & BLOCK_FLAG_RAID10)
-        factor = c->chunk_item->num_stripes / c->chunk_item->sub_stripes;
-    else // SINGLE, DUPLICATE, RAID1
-        factor = 1;
-    
-    cis = (CHUNK_ITEM_STRIPE*)&c->chunk_item[1];
+
+    if (Vcb->space_root) {
+        Status = insert_tree_item_batch(batchlist, Vcb, Vcb->space_root, c->offset, TYPE_FREE_SPACE_INFO, c->chunk_item->size,
+                                        NULL, 0, Batch_DeleteFreeSpace);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item_batch returned %08x\n", Status);
+            return Status;
+        }
+    }
+
     for (i = 0; i < c->chunk_item->num_stripes; i++) {
         if (!c->created) {
             // remove DEV_EXTENTs from tree 4
@@ -4487,69 +5225,87 @@
             searchkey.obj_id = cis[i].dev_id;
             searchkey.obj_type = TYPE_DEV_EXTENT;
             searchkey.offset = cis[i].offset;
-            
+
             Status = find_item(Vcb, Vcb->dev_root, &tp, &searchkey, FALSE, Irp);
             if (!NT_SUCCESS(Status)) {
                 ERR("error - find_item returned %08x\n", Status);
                 return Status;
             }
-            
+
             if (!keycmp(tp.item->key, searchkey)) {
-                delete_tree_item(Vcb, &tp, rollback);
-                
+                Status = delete_tree_item(Vcb, &tp);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("delete_tree_item returned %08x\n", Status);
+                    return Status;
+                }
+
                 if (tp.item->size >= sizeof(DEV_EXTENT)) {
                     DEV_EXTENT* de = (DEV_EXTENT*)tp.item->data;
-                    
+
                     c->devices[i]->devitem.bytes_used -= de->length;
-                    
-                    space_list_add2(Vcb, &c->devices[i]->space, NULL, cis[i].offset, de->length, rollback);
+
+                    if (Vcb->balance.thread && Vcb->balance.shrinking && Vcb->balance.opts[0].devid == c->devices[i]->devitem.dev_id) {
+                        if (cis[i].offset < Vcb->balance.opts[0].drange_start && cis[i].offset + de->length > Vcb->balance.opts[0].drange_start)
+                            space_list_add2(&c->devices[i]->space, NULL, cis[i].offset, Vcb->balance.opts[0].drange_start - cis[i].offset, NULL, rollback);
+                    } else
+                        space_list_add2(&c->devices[i]->space, NULL, cis[i].offset, de->length, NULL, rollback);
                 }
             } else
                 WARN("could not find (%llx,%x,%llx) in dev tree\n", searchkey.obj_id, searchkey.obj_type, searchkey.offset);
         } else {
             UINT64 len = c->chunk_item->size / factor;
-            
+
             c->devices[i]->devitem.bytes_used -= len;
-            space_list_add2(Vcb, &c->devices[i]->space, NULL, cis[i].offset, len, rollback);
+
+            if (Vcb->balance.thread && Vcb->balance.shrinking && Vcb->balance.opts[0].devid == c->devices[i]->devitem.dev_id) {
+                if (cis[i].offset < Vcb->balance.opts[0].drange_start && cis[i].offset + len > Vcb->balance.opts[0].drange_start)
+                    space_list_add2(&c->devices[i]->space, NULL, cis[i].offset, Vcb->balance.opts[0].drange_start - cis[i].offset, NULL, rollback);
+            } else
+                space_list_add2(&c->devices[i]->space, NULL, cis[i].offset, len, NULL, rollback);
         }
     }
-    
+
     // modify DEV_ITEMs in chunk tree
     for (i = 0; i < c->chunk_item->num_stripes; i++) {
         if (c->devices[i]) {
             UINT64 j;
             DEV_ITEM* di;
-            
+
             searchkey.obj_id = 1;
             searchkey.obj_type = TYPE_DEV_ITEM;
             searchkey.offset = c->devices[i]->devitem.dev_id;
-            
+
             Status = find_item(Vcb, Vcb->chunk_root, &tp, &searchkey, FALSE, Irp);
             if (!NT_SUCCESS(Status)) {
                 ERR("error - find_item returned %08x\n", Status);
                 return Status;
             }
-            
+
             if (keycmp(tp.item->key, searchkey)) {
                 ERR("error - could not find DEV_ITEM for device %llx\n", searchkey.offset);
                 return STATUS_INTERNAL_ERROR;
             }
-            
-            delete_tree_item(Vcb, &tp, rollback);
-            
+
+            Status = delete_tree_item(Vcb, &tp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                return Status;
+            }
+
             di = ExAllocatePoolWithTag(PagedPool, sizeof(DEV_ITEM), ALLOC_TAG);
             if (!di) {
                 ERR("out of memory\n");
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
-            
+
             RtlCopyMemory(di, &c->devices[i]->devitem, sizeof(DEV_ITEM));
-            
-            if (!insert_tree_item(Vcb, Vcb->chunk_root, 1, TYPE_DEV_ITEM, c->devices[i]->devitem.dev_id, di, sizeof(DEV_ITEM), NULL, Irp, rollback)) {
-                ERR("insert_tree_item failed\n");
-                return STATUS_INTERNAL_ERROR;
+
+            Status = insert_tree_item(Vcb, Vcb->chunk_root, 1, TYPE_DEV_ITEM, c->devices[i]->devitem.dev_id, di, sizeof(DEV_ITEM), NULL, Irp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("insert_tree_item returned %08x\n", Status);
+                return Status;
             }
-            
+
             for (j = i + 1; j < c->chunk_item->num_stripes; j++) {
                 if (c->devices[j] == c->devices[i])
                     c->devices[j] = NULL;
@@ -4556,199 +5312,516 @@
             }
         }
     }
-    
+
     if (!c->created) {
         // remove CHUNK_ITEM from chunk tree
         searchkey.obj_id = 0x100;
         searchkey.obj_type = TYPE_CHUNK_ITEM;
         searchkey.offset = c->offset;
-        
+
         Status = find_item(Vcb, Vcb->chunk_root, &tp, &searchkey, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("error - find_item returned %08x\n", Status);
             return Status;
         }
-        
-        if (!keycmp(tp.item->key, searchkey))
-            delete_tree_item(Vcb, &tp, rollback);
-        else
+
+        if (!keycmp(tp.item->key, searchkey)) {
+            Status = delete_tree_item(Vcb, &tp);
+
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                return Status;
+            }
+        } else
             WARN("could not find CHUNK_ITEM for chunk %llx\n", c->offset);
-        
+
         // remove BLOCK_GROUP_ITEM from extent tree
         searchkey.obj_id = c->offset;
         searchkey.obj_type = TYPE_BLOCK_GROUP_ITEM;
         searchkey.offset = 0xffffffffffffffff;
-        
+
         Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("error - find_item returned %08x\n", Status);
             return Status;
         }
-        
-        if (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type == searchkey.obj_type)
-            delete_tree_item(Vcb, &tp, rollback);
-        else
+
+        if (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type == searchkey.obj_type) {
+            Status = delete_tree_item(Vcb, &tp);
+
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                return Status;
+            }
+        } else
             WARN("could not find BLOCK_GROUP_ITEM for chunk %llx\n", c->offset);
     }
-    
+
     if (c->chunk_item->type & BLOCK_FLAG_SYSTEM)
         remove_from_bootstrap(Vcb, 0x100, TYPE_CHUNK_ITEM, c->offset);
-    
+
     RemoveEntryList(&c->list_entry);
-    
+
     // clear raid56 incompat flag if dropping last RAID5/6 chunk
-    
+
     if (c->chunk_item->type & BLOCK_FLAG_RAID5 || c->chunk_item->type & BLOCK_FLAG_RAID6) {
         LIST_ENTRY* le;
         BOOL clear_flag = TRUE;
-        
+
         le = Vcb->chunks.Flink;
         while (le != &Vcb->chunks) {
             chunk* c2 = CONTAINING_RECORD(le, chunk, list_entry);
-            
+
             if (c2->chunk_item->type & BLOCK_FLAG_RAID5 || c2->chunk_item->type & BLOCK_FLAG_RAID6) {
                 clear_flag = FALSE;
                 break;
             }
-            
+
             le = le->Flink;
         }
-        
+
         if (clear_flag)
             Vcb->superblock.incompat_flags &= ~BTRFS_INCOMPAT_FLAGS_RAID56;
     }
-    
+
     Vcb->superblock.bytes_used -= c->oldused;
-    
-    if (c->list_entry_changed.Flink)
-        RemoveEntryList(&c->list_entry_changed);
-    
+
     ExFreePool(c->chunk_item);
     ExFreePool(c->devices);
-    
+
     while (!IsListEmpty(&c->space)) {
         space* s = CONTAINING_RECORD(c->space.Flink, space, list_entry);
-        
+
         RemoveEntryList(&s->list_entry);
         ExFreePool(s);
     }
-    
+
     while (!IsListEmpty(&c->deleting)) {
         space* s = CONTAINING_RECORD(c->deleting.Flink, space, list_entry);
-        
+
         RemoveEntryList(&s->list_entry);
         ExFreePool(s);
     }
-    
+
+    ExDeleteResourceLite(&c->partial_stripes_lock);
+    ExDeleteResourceLite(&c->range_locks_lock);
     ExDeleteResourceLite(&c->lock);
     ExDeleteResourceLite(&c->changed_extents_lock);
 
     ExFreePool(c);
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS update_chunks(device_extension* Vcb, LIST_ENTRY* batchlist, PIRP Irp, LIST_ENTRY* rollback) {
-    LIST_ENTRY *le = Vcb->chunks_changed.Flink, *le2;
+static NTSTATUS partial_stripe_read(device_extension* Vcb, chunk* c, partial_stripe* ps, UINT64 startoff, UINT16 parity, ULONG offset, ULONG len) {
     NTSTATUS Status;
-    UINT64 used_minus_cache;
-    
-    ExAcquireResourceExclusiveLite(&Vcb->chunk_lock, TRUE);
-    
-    // FIXME - do tree chunks before data chunks
-    
-    while (le != &Vcb->chunks_changed) {
-        chunk* c = CONTAINING_RECORD(le, chunk, list_entry_changed);
-        
-        le2 = le->Flink;
-        
-        ExAcquireResourceExclusiveLite(&c->lock, TRUE);
-        
-        if (c->list_entry_balance.Flink) {
-            ExReleaseResourceLite(&c->lock);
-            le = le2;
-            continue;
-        }
-        
-        used_minus_cache = c->used;
-        
-        // subtract self-hosted cache
-        if (used_minus_cache > 0 && c->chunk_item->type & BLOCK_FLAG_DATA && c->cache && c->cache->inode_item.st_size == c->used) {
-            LIST_ENTRY* le3;
-            
-            le3 = c->cache->extents.Flink;
-            while (le3 != &c->cache->extents) {
-                extent* ext = CONTAINING_RECORD(le3, extent, list_entry);
-                EXTENT_DATA* ed = ext->data;
-                
-                if (!ext->ignore) {
-                    if (ext->datalen < sizeof(EXTENT_DATA)) {
-                        ERR("extent %llx was %u bytes, expected at least %u\n", ext->offset, ext->datalen, sizeof(EXTENT_DATA));
-                        break;
+    ULONG sl = (ULONG)(c->chunk_item->stripe_length / Vcb->superblock.sector_size);
+    CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&c->chunk_item[1];
+
+    while (len > 0) {
+        ULONG readlen = min(offset + len, offset + (sl - (offset % sl))) - offset;
+        UINT16 stripe;
+
+        stripe = (parity + (offset / sl) + 1) % c->chunk_item->num_stripes;
+
+        if (c->devices[stripe]->devobj) {
+            Status = sync_read_phys(c->devices[stripe]->devobj, cis[stripe].offset + startoff + ((offset % sl) * Vcb->superblock.sector_size),
+                                    readlen * Vcb->superblock.sector_size, ps->data + (offset * Vcb->superblock.sector_size), FALSE);
+            if (!NT_SUCCESS(Status)) {
+                ERR("sync_read_phys returned %08x\n", Status);
+                return Status;
+            }
+        } else if (c->chunk_item->type & BLOCK_FLAG_RAID5) {
+            UINT16 i;
+            UINT8* scratch;
+
+            scratch = ExAllocatePoolWithTag(NonPagedPool, readlen * Vcb->superblock.sector_size, ALLOC_TAG);
+            if (!scratch) {
+                ERR("out of memory\n");
+                return STATUS_INSUFFICIENT_RESOURCES;
+            }
+
+            for (i = 0; i < c->chunk_item->num_stripes; i++) {
+                if (i != stripe) {
+                    if (!c->devices[i]->devobj) {
+                        ExFreePool(scratch);
+                        return STATUS_UNEXPECTED_IO_ERROR;
                     }
-                    
-                    if (ed->type == EXTENT_TYPE_REGULAR || ed->type == EXTENT_TYPE_PREALLOC) {
-                        EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ed->data;
-                        
-                        if (ext->datalen < sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2)) {
-                            ERR("extent %llx was %u bytes, expected at least %u\n", ext->offset, ext->datalen,
-                                sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2));
-                            break;
+
+                    if (i == 0 || (stripe == 0 && i == 1)) {
+                        Status = sync_read_phys(c->devices[i]->devobj, cis[i].offset + startoff + ((offset % sl) * Vcb->superblock.sector_size),
+                                                readlen * Vcb->superblock.sector_size, ps->data + (offset * Vcb->superblock.sector_size), FALSE);
+                        if (!NT_SUCCESS(Status)) {
+                            ERR("sync_read_phys returned %08x\n", Status);
+                            ExFreePool(scratch);
+                            return Status;
                         }
-                        
-                        if (ed2->size != 0 && ed2->address >= c->offset && ed2->address + ed2->size <= c->offset + c->chunk_item->size)
-                            used_minus_cache -= ed2->size;
+                    } else {
+                        Status = sync_read_phys(c->devices[i]->devobj, cis[i].offset + startoff + ((offset % sl) * Vcb->superblock.sector_size),
+                                                readlen * Vcb->superblock.sector_size, scratch, FALSE);
+                        if (!NT_SUCCESS(Status)) {
+                            ERR("sync_read_phys returned %08x\n", Status);
+                            ExFreePool(scratch);
+                            return Status;
+                        }
+
+                        do_xor(ps->data + (offset * Vcb->superblock.sector_size), scratch, readlen * Vcb->superblock.sector_size);
                     }
                 }
-                
-                le3 = le3->Flink;
             }
+
+            ExFreePool(scratch);
+        } else {
+            UINT8* scratch;
+            UINT16 k, i, logstripe, error_stripe, num_errors = 0;
+
+            scratch = ExAllocatePoolWithTag(NonPagedPool, (c->chunk_item->num_stripes + 2) * readlen * Vcb->superblock.sector_size, ALLOC_TAG);
+            if (!scratch) {
+                ERR("out of memory\n");
+                return STATUS_INSUFFICIENT_RESOURCES;
+            }
+
+            i = (parity + 1) % c->chunk_item->num_stripes;
+            for (k = 0; k < c->chunk_item->num_stripes; k++) {
+                if (i != stripe) {
+                    if (c->devices[i]->devobj) {
+                        Status = sync_read_phys(c->devices[i]->devobj, cis[i].offset + startoff + ((offset % sl) * Vcb->superblock.sector_size),
+                                                readlen * Vcb->superblock.sector_size, scratch + (k * readlen * Vcb->superblock.sector_size), FALSE);
+                        if (!NT_SUCCESS(Status)) {
+                            ERR("sync_read_phys returned %08x\n", Status);
+                            num_errors++;
+                            error_stripe = k;
+                        }
+                    } else {
+                        num_errors++;
+                        error_stripe = k;
+                    }
+
+                    if (num_errors > 1) {
+                        ExFreePool(scratch);
+                        return STATUS_UNEXPECTED_IO_ERROR;
+                    }
+                } else
+                    logstripe = k;
+
+                i = (i + 1) % c->chunk_item->num_stripes;
+            }
+
+            if (num_errors == 0 || error_stripe == c->chunk_item->num_stripes - 1) {
+                for (k = 0; k < c->chunk_item->num_stripes - 1; k++) {
+                    if (k != logstripe) {
+                        if (k == 0 || (k == 1 && logstripe == 0)) {
+                            RtlCopyMemory(ps->data + (offset * Vcb->superblock.sector_size), scratch + (k * readlen * Vcb->superblock.sector_size),
+                                          readlen * Vcb->superblock.sector_size);
+                        } else {
+                            do_xor(ps->data + (offset * Vcb->superblock.sector_size), scratch + (k * readlen * Vcb->superblock.sector_size),
+                                   readlen * Vcb->superblock.sector_size);
+                        }
+                    }
+                }
+            } else {
+                raid6_recover2(scratch, c->chunk_item->num_stripes, readlen * Vcb->superblock.sector_size, logstripe,
+                               error_stripe, scratch + (c->chunk_item->num_stripes * readlen * Vcb->superblock.sector_size));
+
+                RtlCopyMemory(ps->data + (offset * Vcb->superblock.sector_size), scratch + (c->chunk_item->num_stripes * readlen * Vcb->superblock.sector_size),
+                              readlen * Vcb->superblock.sector_size);
+            }
+
+            ExFreePool(scratch);
         }
-        
-        if (used_minus_cache == 0) {
-            Status = drop_chunk(Vcb, c, batchlist, Irp, rollback);
+
+        offset += readlen;
+        len -= readlen;
+    }
+
+    return STATUS_SUCCESS;
+}
+
+NTSTATUS flush_partial_stripe(device_extension* Vcb, chunk* c, partial_stripe* ps) {
+    NTSTATUS Status;
+    UINT16 parity2, stripe, startoffstripe;
+    UINT8* data;
+    UINT64 startoff;
+    ULONG runlength, index, last1;
+    CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&c->chunk_item[1];
+    LIST_ENTRY* le;
+    UINT16 k, num_data_stripes = c->chunk_item->num_stripes - (c->chunk_item->type & BLOCK_FLAG_RAID5 ? 1 : 2);
+    UINT64 ps_length = num_data_stripes * c->chunk_item->stripe_length;
+    ULONG stripe_length = (ULONG)c->chunk_item->stripe_length;
+
+    // FIXME - do writes asynchronously?
+
+    get_raid0_offset(ps->address - c->offset, stripe_length, num_data_stripes, &startoff, &startoffstripe);
+
+    parity2 = (((ps->address - c->offset) / ps_length) + c->chunk_item->num_stripes - 1) % c->chunk_item->num_stripes;
+
+    // read data (or reconstruct if degraded)
+
+    runlength = RtlFindFirstRunClear(&ps->bmp, &index);
+    last1 = 0;
+
+    while (runlength != 0) {
+        if (index > last1) {
+            Status = partial_stripe_read(Vcb, c, ps, startoff, parity2, last1, index - last1);
             if (!NT_SUCCESS(Status)) {
-                ERR("drop_chunk returned %08x\n", Status);
-                ExReleaseResourceLite(&c->lock);
-                ExReleaseResourceLite(&Vcb->chunk_lock);
+                ERR("partial_stripe_read returned %08x\n", Status);
                 return Status;
             }
-        } else if (c->created) {
-            Status = create_chunk(Vcb, c, Irp, rollback);
+        }
+
+        last1 = index + runlength;
+
+        runlength = RtlFindNextForwardRunClear(&ps->bmp, index + runlength, &index);
+    }
+
+    if (last1 < ps_length / Vcb->superblock.sector_size) {
+        Status = partial_stripe_read(Vcb, c, ps, startoff, parity2, last1, (ULONG)((ps_length / Vcb->superblock.sector_size) - last1));
+        if (!NT_SUCCESS(Status)) {
+            ERR("partial_stripe_read returned %08x\n", Status);
+            return Status;
+        }
+    }
+
+    // set unallocated data to 0
+    le = c->space.Flink;
+    while (le != &c->space) {
+        space* s = CONTAINING_RECORD(le, space, list_entry);
+
+        if (s->address + s->size > ps->address && s->address < ps->address + ps_length) {
+            UINT64 start = max(ps->address, s->address);
+            UINT64 end = min(ps->address + ps_length, s->address + s->size);
+
+            RtlZeroMemory(ps->data + start - ps->address, (ULONG)(end - start));
+        } else if (s->address >= ps->address + ps_length)
+            break;
+
+        le = le->Flink;
+    }
+
+    le = c->deleting.Flink;
+    while (le != &c->deleting) {
+        space* s = CONTAINING_RECORD(le, space, list_entry);
+
+        if (s->address + s->size > ps->address && s->address < ps->address + ps_length) {
+            UINT64 start = max(ps->address, s->address);
+            UINT64 end = min(ps->address + ps_length, s->address + s->size);
+
+            RtlZeroMemory(ps->data + start - ps->address, (ULONG)(end - start));
+        } else if (s->address >= ps->address + ps_length)
+            break;
+
+        le = le->Flink;
+    }
+
+    stripe = (parity2 + 1) % c->chunk_item->num_stripes;
+
+    data = ps->data;
+    for (k = 0; k < num_data_stripes; k++) {
+        if (c->devices[stripe]->devobj) {
+            Status = write_data_phys(c->devices[stripe]->devobj, cis[stripe].offset + startoff, data, stripe_length);
             if (!NT_SUCCESS(Status)) {
-                ERR("create_chunk returned %08x\n", Status);
-                ExReleaseResourceLite(&c->lock);
-                ExReleaseResourceLite(&Vcb->chunk_lock);
+                ERR("write_data_phys returned %08x\n", Status);
                 return Status;
             }
         }
-        
-        if (used_minus_cache > 0)
-            ExReleaseResourceLite(&c->lock);
 
+        data += stripe_length;
+        stripe = (stripe + 1) % c->chunk_item->num_stripes;
+    }
+
+    // write parity
+    if (c->chunk_item->type & BLOCK_FLAG_RAID5) {
+        if (c->devices[parity2]->devobj) {
+            UINT16 i;
+
+            for (i = 1; i < c->chunk_item->num_stripes - 1; i++) {
+                do_xor(ps->data, ps->data + (i * stripe_length), stripe_length);
+            }
+
+            Status = write_data_phys(c->devices[parity2]->devobj, cis[parity2].offset + startoff, ps->data, stripe_length);
+            if (!NT_SUCCESS(Status)) {
+                ERR("write_data_phys returned %08x\n", Status);
+                return Status;
+            }
+        }
+    } else {
+        UINT16 parity1 = (parity2 + c->chunk_item->num_stripes - 1) % c->chunk_item->num_stripes;
+
+        if (c->devices[parity1]->devobj || c->devices[parity2]->devobj) {
+            UINT8* scratch;
+            UINT16 i;
+
+            scratch = ExAllocatePoolWithTag(NonPagedPool, stripe_length * 2, ALLOC_TAG);
+            if (!scratch) {
+                ERR("out of memory\n");
+                return STATUS_INSUFFICIENT_RESOURCES;
+            }
+
+            i = c->chunk_item->num_stripes - 3;
+
+            while (TRUE) {
+                if (i == c->chunk_item->num_stripes - 3) {
+                    RtlCopyMemory(scratch, ps->data + (i * stripe_length), stripe_length);
+                    RtlCopyMemory(scratch + stripe_length, ps->data + (i * stripe_length), stripe_length);
+                } else {
+                    do_xor(scratch, ps->data + (i * stripe_length), stripe_length);
+
+                    galois_double(scratch + stripe_length, stripe_length);
+                    do_xor(scratch + stripe_length, ps->data + (i * stripe_length), stripe_length);
+                }
+
+                if (i == 0)
+                    break;
+
+                i--;
+            }
+
+            if (c->devices[parity1]->devobj) {
+                Status = write_data_phys(c->devices[parity1]->devobj, cis[parity1].offset + startoff, scratch, stripe_length);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("write_data_phys returned %08x\n", Status);
+                    ExFreePool(scratch);
+                    return Status;
+                }
+            }
+
+            if (c->devices[parity2]->devobj) {
+                Status = write_data_phys(c->devices[parity2]->devobj, cis[parity2].offset + startoff, scratch + stripe_length, stripe_length);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("write_data_phys returned %08x\n", Status);
+                    ExFreePool(scratch);
+                    return Status;
+                }
+            }
+
+            ExFreePool(scratch);
+        }
+    }
+
+    return STATUS_SUCCESS;
+}
+
+static NTSTATUS update_chunks(device_extension* Vcb, LIST_ENTRY* batchlist, PIRP Irp, LIST_ENTRY* rollback) {
+    LIST_ENTRY *le, *le2;
+    NTSTATUS Status;
+    UINT64 used_minus_cache;
+
+    ExAcquireResourceExclusiveLite(&Vcb->chunk_lock, TRUE);
+
+    // FIXME - do tree chunks before data chunks
+
+    le = Vcb->chunks.Flink;
+    while (le != &Vcb->chunks) {
+        chunk* c = CONTAINING_RECORD(le, chunk, list_entry);
+
+        le2 = le->Flink;
+
+        if (c->changed) {
+            ExAcquireResourceExclusiveLite(&c->lock, TRUE);
+
+            // flush partial stripes
+            if (!Vcb->readonly && (c->chunk_item->type & BLOCK_FLAG_RAID5 || c->chunk_item->type & BLOCK_FLAG_RAID6)) {
+                ExAcquireResourceExclusiveLite(&c->partial_stripes_lock, TRUE);
+
+                while (!IsListEmpty(&c->partial_stripes)) {
+                    partial_stripe* ps = CONTAINING_RECORD(RemoveHeadList(&c->partial_stripes), partial_stripe, list_entry);
+
+                    Status = flush_partial_stripe(Vcb, c, ps);
+
+                    if (ps->bmparr)
+                        ExFreePool(ps->bmparr);
+
+                    ExFreePool(ps);
+
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("flush_partial_stripe returned %08x\n", Status);
+                        ExReleaseResourceLite(&c->partial_stripes_lock);
+                        ExReleaseResourceLite(&c->lock);
+                        ExReleaseResourceLite(&Vcb->chunk_lock);
+                        return Status;
+                    }
+                }
+
+                ExReleaseResourceLite(&c->partial_stripes_lock);
+            }
+
+            if (c->list_entry_balance.Flink) {
+                ExReleaseResourceLite(&c->lock);
+                le = le2;
+                continue;
+            }
+
+            if (c->space_changed || c->created) {
+                used_minus_cache = c->used;
+
+                // subtract self-hosted cache
+                if (used_minus_cache > 0 && c->chunk_item->type & BLOCK_FLAG_DATA && c->cache && c->cache->inode_item.st_size == c->used) {
+                    LIST_ENTRY* le3;
+
+                    le3 = c->cache->extents.Flink;
+                    while (le3 != &c->cache->extents) {
+                        extent* ext = CONTAINING_RECORD(le3, extent, list_entry);
+                        EXTENT_DATA* ed = &ext->extent_data;
+
+                        if (!ext->ignore) {
+                            if (ed->type == EXTENT_TYPE_REGULAR || ed->type == EXTENT_TYPE_PREALLOC) {
+                                EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ed->data;
+
+                                if (ed2->size != 0 && ed2->address >= c->offset && ed2->address + ed2->size <= c->offset + c->chunk_item->size)
+                                    used_minus_cache -= ed2->size;
+                            }
+                        }
+
+                        le3 = le3->Flink;
+                    }
+                }
+
+                if (used_minus_cache == 0) {
+                    Status = drop_chunk(Vcb, c, batchlist, Irp, rollback);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("drop_chunk returned %08x\n", Status);
+                        ExReleaseResourceLite(&c->lock);
+                        ExReleaseResourceLite(&Vcb->chunk_lock);
+                        return Status;
+                    }
+                } else if (c->created) {
+                    Status = create_chunk(Vcb, c, Irp);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("create_chunk returned %08x\n", Status);
+                        ExReleaseResourceLite(&c->lock);
+                        ExReleaseResourceLite(&Vcb->chunk_lock);
+                        return Status;
+                    }
+                }
+
+                if (used_minus_cache > 0)
+                    ExReleaseResourceLite(&c->lock);
+            }
+        }
+
         le = le2;
     }
-    
+
     ExReleaseResourceLite(&Vcb->chunk_lock);
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS delete_root_ref(device_extension* Vcb, UINT64 subvolid, UINT64 parsubvolid, UINT64 parinode, PANSI_STRING utf8, PIRP Irp, LIST_ENTRY* rollback) {
+static NTSTATUS delete_root_ref(device_extension* Vcb, UINT64 subvolid, UINT64 parsubvolid, UINT64 parinode, PANSI_STRING utf8, PIRP Irp) {
     KEY searchkey;
     traverse_ptr tp;
     NTSTATUS Status;
-    
+
     searchkey.obj_id = parsubvolid;
     searchkey.obj_type = TYPE_ROOT_REF;
     searchkey.offset = subvolid;
-    
+
     Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
         return Status;
     }
-    
+
     if (!keycmp(searchkey, tp.item->key)) {
         if (tp.item->size < sizeof(ROOT_REF)) {
             ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(ROOT_REF));
